<?php
set_time_limit(30);
//error_reporting(E_NOTICE);

/*
Plugin Name: WP Auto Articles
Plugin URI: http://wpautoarticles.com
Description: Fetch articles from Article directories and create posts
Version: 1.3
Author: Austin Delaney <austin@wpautoarticles.com>
Author URI: http://wpautoarticles.com

*/
// Include the RSS functions. Older versions of wordpress could use include_once (ABSPATH . WPINC . '/rss-functions.php') or

include_once (ABSPATH . WPINC . '/rss.php');;

//include_once(ABSPATH . WPINC . '/feed.php');

register_activation_hook(__FILE__,'as_installation');

register_deactivation_hook(__FILE__,'as_uninstallation');

add_action ( 'admin_menu', 'as_settings' );

add_action('admin_init', 'as_init_method');

//add_action('wp_footer', 'as_spawn_cron');

add_action('as_cron','as_process_cron');

function as_init_method() {
	//wp_register_script('asjs',WP_PLUGIN_URL.'/script.js');
	wp_enqueue_script('asjs',WP_PLUGIN_URL.'/autoarticles/script.js');
    //wp_enqueue_script('scriptaculous');
}

function as_process_cron(){
	global $wpdb;
	//wp_mail(get_option('admin_email'),'Auto Articles Cron','Auto Articles Cron is just started');
	//fetch the keywords that has not processed in last 24 hours
	$timestamp = strtotime("-24 hours");
	$query = "SELECT * FROM `{$wpdb->prefix}as_keywords` WHERE `status`='active' AND `last_ran` <= $timestamp";
	$keywords = $wpdb->get_results($query);

	if(!count($keywords)){
		echo 'Sorry, no keyword is scheduled to run now.';
		return;
	} else {
		foreach ($keywords as $keyword){
			echo '<h3>Processing keyword: '.$keyword->keyword .'</h3><br />';
			flush();
			$result = as_fetch_articles($keyword->keyword,$keyword->category,$keyword->tags,$keyword->author_dofollow_link,$keyword->keep_article_source,$keyword->num_posts);
			//update the keyword info
			$update_result = $wpdb->update("{$wpdb->prefix}as_keywords",array("last_ran"=>time()),array("id"=>$keyword->id));
			if(!$update_result) wp_mail(get_option('admin_email'),'Auto Articles Cron Error','Auto Articles Cron stopped at error: '.$wpdb->last_error .' in query: '.$wpdb->last_query);
			echo "Ran keyword <b>{$keyword->name}</b> ({$keyword->id}) successfully";


			flush();
		}
	}
	//wp_mail(get_option('admin_email'),'Auto Articles Cron','Auto Articles Cron is just finished');
}

function as_installation(){
	global $wpdb;
	$wpdb->show_errors(true);
	$wpdb->query("CREATE TABLE `{$wpdb->prefix}as_keywords` (
	`id` SERIAL NOT NULL ,
	`keyword` VARCHAR( 100 ) NOT NULL ,
	`num_posts` TINYINT NOT NULL ,
	`category` INT NOT NULL ,
	`tags` VARCHAR( 100 ) NOT NULL,
	`author_dofollow_link` bool NOT NULL default false,
	`keep_article_source` bool NOT NULL default false,
	`status` VARCHAR( 20 ) NOT NULL ,
	`added` INT NOT NULL,
	`last_ran` INT NOT NULL
	) ENGINE = MYISAM ;");

	as_set_schedule();
	add_option('as_last_cron',0);
}

function as_uninstallation(){
	global $wpdb;
	$wpdb->query("DROP TABLE {$wpdb->prefix}as_keywords");

	delete_option('as_last_cron');
	as_unset_schedule();
}


function as_settings() {
	add_options_page ( 'Auto Articles', 'Auto Articles', 9, basename ( __FILE__ ), 'as_settings_page' );
}

function as_settings_page() {
	global $wpdb;
	//show current crons

	if(!empty($_GET['action']) AND !empty($_GET['id'])){
		switch ($_GET['action']){
			case 'delete':
				echo as_del_key($_GET['id']);
				break;
			case 'active':
			case 'inactive':
				echo as_enable_disable_key($_GET['id'],$_GET['action']);
				break;
			case 'post_now':
				echo as_process_single_key($_GET['id']);
				break;
		}
	}

	if(isset($_POST['doaction_selected'])){
		as_handle_selected_keywords();
	}
	if (isset( $_POST ['as_fetch']) AND !empty($_POST['keywords'])) {
		$num_items = (empty($_POST['num_items'])) ? 1 : $_POST['num_items'];
		set_time_limit($num_items*45);
		as_fetch_articles($_POST['keywords'],$_POST['as_cat'],$_POST['as_tags'],$_POST['as_author_dofollow'],$_POST['keep_article_source'],$num_items);
	}
	if(isset($_POST['as_run_cron'])){
		as_process_cron();
	}
	if(isset($_POST['doaddkeyword'])){
		if(empty($_POST['keyword']) OR empty($_POST['num_posts'])){
			echo 'You must enter keyword and number of posts each day';
		} else {
			//save them to database.
			$exists_in_db=$wpdb->get_var("SELECT count(*) FROM `{$wpdb->prefix}as_keywords` WHERE `keyword` LIKE '".$wpdb->escape($_POST['keyword'])."'");
			if($exists_in_db){
				echo 'This keyword already exists in database';
			} else {
				$wpdb->show_errors(true);
				$result = $wpdb->insert("{$wpdb->prefix}as_keywords",array("keyword"=>$_POST['keyword'],"num_posts"=>$_POST['num_posts'],"status"=>"active","added"=>time(),"category"=>$_POST['as_cat'],"tags"=>$_POST['as_tags'],"author_dofollow_link"=>$_POST['as_author_dofollow'], "keep_article_source"=>$_POST['keep_article_source']),array('%s','%d','%s','%d','%d','%s','%d'));

				if($result){
					echo 'Keyword inserted successfully';
				} else {
					echo 'Keyword could not be inserted';
					echo '<br />MySQL Said: ' . $wpdb->last_error;
				}
			}
		}
	}
	?>

<div class="wrap">
	<div id="icon-tools" class="icon32"><br /></div>
<h2><?php _e("Auto Articles Cron Setup", "auto_articles"); ?></h2>
<b>Current Cron Script Run Interval: </b> <?PHP echo wp_get_schedule('as_cron');?> <br />

<form id="jobs-filter" action="?page=auto_articles.php" method="post">
<?php wp_nonce_field('actions-jobs'); ?>
<div class="tablenav">

	<div class="alignleft actions">
	<label>Keyword: <input type="text" name="keyword" /></label>
	<label>Num of Posts each day:<input type="text" name="num_posts" size="5" /> </label>
	<label>Category: <?php wp_dropdown_categories('hide_empty=0&name=as_cat') ?> </label>
	<label>Common Tags:  <input type="text" name="as_tags" /></label>
	<label>"Do-Follow" Author link?:  <input type="hidden" name="as_author_dofollow" value="0" /><input type="checkbox" name="as_author_dofollow" value="1" /></label>
	<label>Keep article source?:  <input type="hidden" name="keep_article_source" value="0" /><input type="checkbox" name="keep_article_source" value="1" /></label>	
	<input type="submit" value="<?PHP _e('Add','auto_articles'); ?>" name="doaddkeyword" id="doaddkeyword" class="button-secondary action" />
	</div>

<br class="clear" />
</div>
</form>
<div class="clear"></div>
<form action="?page=auto_articles.php" method="post">
<table class="widefat fixed" cellspacing="0">
	<thead>
	<tr>
	<th scope="col" id="cb" class="manage-column column-cb check-column" style=""><input type="checkbox" /></th>
	<th scope="col" id="id" class="manage-column column-id" style=""><?PHP _e('ID','auto_articles'); ?></th>
	<th scope="col" id="name" class="manage-column column-name" style=""><?PHP _e('Keyword','auto_articles'); ?></th>
	<th scope="col" id="type" class="manage-column column-type" style=""><?PHP _e('Daily Posts','auto_articles'); ?></th>
	<th scope="col" id="type" class="manage-column column-type" style=""><?PHP _e('Category','auto_articles'); ?></th>
	<th scope="col" id="type" class="manage-column column-type" style=""><?PHP _e('Tags','auto_articles'); ?></th>
	<th scope="col" id="type" class="manage-column column-type" style=""><?PHP _e('Last Run','auto_articles'); ?></th>
	<th scope="col" id="type" class="manage-column column-type" style=""><?PHP _e('Status','auto_articles'); ?></th>
	<th scope="col" id="last" class="manage-column column-last" style=""><?PHP _e('Options','auto_articles'); ?></th>
	</tr>
	</thead>

	<tfoot>
	<tr>
	<th scope="col" id="cb" class="manage-column column-cb check-column" style=""><input type="checkbox" /></th>
	<th scope="col" id="id" class="manage-column column-id" style=""><?PHP _e('ID','auto_articles'); ?></th>
	<th scope="col" id="name" class="manage-column column-name" style=""><?PHP _e('Keyword','auto_articles'); ?></th>
	<th scope="col" id="type" class="manage-column column-type" style=""><?PHP _e('Daily Posts','auto_articles'); ?></th>
	<th scope="col" id="type" class="manage-column column-type" style=""><?PHP _e('Category','auto_articles'); ?></th>
	<th scope="col" id="type" class="manage-column column-type" style=""><?PHP _e('Tags','auto_articles'); ?></th>
	<th scope="col" id="type" class="manage-column column-type" style=""><?PHP _e('Last Run','auto_articles'); ?></th>
	<th scope="col" id="type" class="manage-column column-type" style=""><?PHP _e('Status','auto_articles'); ?></th>
	<th scope="col" id="last" class="manage-column column-last" style=""><?PHP _e('Options','auto_articles'); ?></th>
	</tr>
	</tfoot>

	<tbody id="the-list" class="list:post">

	<?php
	$keywords = $wpdb->get_results("SELECT * FROM {$wpdb->prefix}as_keywords ORDER BY `id` DESC LIMIT 1000",ARRAY_A);

	if (is_array($keywords)) { foreach ($keywords as $keyword) {?>
	<tr id="job-<?PHP echo $keyword['id'];?>" class="alternate status-inherit" valign="top">
		<th scope="row" class="check-column">
			<input type="checkbox" name="keyword_id[]" value="<?PHP echo $keyword['id'];?>" />
		</th>
		<td><?PHP echo $keyword['id'];?></td>
		<td><strong><?PHP echo $keyword['keyword']?></strong></td>
		<td><?PHP echo $keyword['num_posts']?></td>
		<td><?php
		if(!empty($keyword['category'])){
			$cats = get_category($keyword['category']);
			echo $cats->name;
		}
		?></td>
		<td><?PHP echo $keyword['tags']?></td>
		<td><?PHP
		if(!empty($keyword['last_ran'])){
			echo date('d-m-Y h:i:s A',$keyword['last_ran']);
		} else {
			echo _e('Never');
		}
		?></td>
		<td><?PHP echo $keyword['status']?></td>
		<td class="column-next"><a class="deletekey" href="?page=auto_articles.php&action=delete&id=<?PHP echo $keyword['id']?>">Delete</a> |
		<?php
		if($keyword['status']=='active'){
			echo '<a class="disablekey" href="?page=auto_articles.php&action=inactive&id='.$keyword['id'].'">Disable</a>';
		} else {
			echo '<a class="disablekey" href="?page=auto_articles.php&action=active&id='.$keyword['id'].'">Enable</a>';
		}
		?>
		| <a class="postkey" href="?page=auto_articles.php&action=post_now&id=<?PHP echo $keyword['id']?>">Post Now</a></td>
	</tr>
	<?PHP }}?>
	</tbody>
</table>

<div class="tablenav">
	<div class="alignleft actions">
	<select name="selected_type" class="select-action">
	<option value="-1" selected="selected"><?PHP _e('Bulk Actions','backwpup'); ?></option>
	<option value="post_selected"><?PHP _e('Post Selected Now','auto_articles'); ?></option>
	<option value="delete"><?PHP _e('Delete','auto_articles'); ?></option>
	</select>
	<input type="submit" value="<?PHP _e('Apply','auto_articles'); ?>" name="doaction_selected" id="doaction_selected" class="button-secondary action" />
	</div>
</div>
</form>
<br class="clear" />
</div>
<div class="wrap">
	<form action="?page=auto_articles.php" method="post">
		<p class="submit"><?php	wp_nonce_field ( md5 ( __FILE__ ) );?>
		<input type="submit" name="as_run_cron" value="Run the Cron Job Right Now &raquo;" /></p>
	</form>
	<br class="clear" />
</div>


<div class="wrap">
<h2>Instant Auto Articles</h2>
<form action="?page=auto_articles.php" method="post">
Search Keywords: <input type="text" name="keywords" /><br />
Posts Category:  <?php wp_dropdown_categories('hide_empty=0&name=as_cat') ?> <br />
Common Tags:  <input type="text" name="as_tags" /><br />
"Do-Follow" Author link?:  <input type="hidden" name="as_author_dofollow" value="0" /><input type="checkbox" name="as_author_dofollow" value="1" /><br />
Keep article source?:  <input type="hidden" name="keep_article_source" value="0" /><input type="checkbox" name="keep_article_source" value="1" /><br />
Limit Items:  <input type="text" name="num_items" value="5" /><br />
<p class="submit">
	<?php
	wp_nonce_field ( md5 ( __FILE__ ) );
	?>
<input type="submit" name="as_fetch" value="Fetch Articles &raquo;" /></p>
</form>


</div>
<?php
	}

function as_fetch_articles($keywords,$category='',$tags='',$author_dofollow,$keep_article_source,$num_items=1){
//include (ABSPATH . WPINC . '/feed.php');
	$url = 'http://www.articlesnatch.com/rss2/'.urlencode($keywords);

	//echo $url;
	//fetch the rss
	//echo 'fetching rss...';
	$rss = fetch_rss($url);

	if(empty($rss)){
		echo "Sorry, no feed found for keyword: $keywords...";
	} else {
		echo 'feed found, processing...';
		echo count($rss->items) .' items found in the feed ....';
		//limit number of posts
		//$rss = array_slice($rss->items,0,$num_items);
		$rss = $rss->items;
		echo '<h3>start of processing each item...</h3>';
		$i=0;
		$added_posts = array();
		foreach ($rss as $item){
			echo '<ul>';
			echo '<b>Processing a new item</b>';
			//check if the guid already exists in database
			if(as_is_article_exists($item['guid'])){
				echo '<li>Skipping this article as it already exists in database. </li>';

			} else {
				$i++;
				$article = array();
				//echo $item['title'].' '.$item['link'] .'<br />';
				$article['title'] = as_clean_title($item['title']);
				$article['link'] = $item['link'];

				echo '<li>fetching detail of '.$item['link'].'</li>';
				flush();
				as_fetch_single_article($item['link'],$article,$author_dofollow, $keep_article_source);
				echo '<li>fetching detail of '.$item['link'].' is completed...</li>';
			//	print_r($fetch_one);
				if(!empty($article['description'])){
					//add post to wordpress
					echo '<li>adding post </li>';
					$pid = as_addpost($article['title'],$article['description'].'<br />'.$article['author'],$tags,$category,$item['guid']);
					if($pid){
						echo '<li>Post Added '.$pid .' ('.$item['title'].') </li>';
						$added_posts[]= $pid;
						//return $pid;
					} else {
						echo '<li>Unknown error occured while adding post</li>';

					}
					echo '<br />';
				} else {
					echo '<li>Skipping this article as nothing found in description. </li>';

				}
			}
				echo '</ul><hr />';
				//flush();
			if($i>=$num_items) break;
		}
	}
	return $added_posts;
}

function as_fetch_single_article($url,&$article,$author_dofollow,$keep_article_source){

	//echo 'preparing curl...';
	flush();
	// create a new cURL resource
	$ch = curl_init($url);
	// set URL and other appropriate options
	//curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 60);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER,true);
	curl_setopt($ch, CURLOPT_MAXREDIRS,2);

	// grab URL and pass it to the browser
	//echo 'executing curl ...';
	flush();
	$text = curl_exec($ch);

	$con_info = curl_getinfo($ch);
	//echo $text;
	// close cURL resource, and free up system resources
	curl_close($ch);
	//echo 'closing curl ...';
	flush();
	//print_r($con_info);
	//$text  = file_get_contents($url);

	//echo $con_info['http_code'];

	if($con_info['http_code']!='200') return false;
	//$article = array();
	//get description
	//echo 'preparing description ..';
	flush();
	$desc = strstr($text,'<div class="articletext">');
	$end = stripos($desc,'</div>');
	$desc = substr($desc,0,$end);
	$article['description'] = as_clean_description($desc);
	//echo $article['description'];
	//echo 'preparing author <br />';
	flush();
	//now get author info
	$author = strstr($text,'<p class="articletext"><b>About the Author:</b>');
	$end = stripos($author,'</p>');
	$author = substr($author,0,$end);
	$author = as_clean_author($author);
	$article['author'] = handle_author_dofollow($author, $author_dofollow);
	
	//now get article source info
	$article_source = strstr($text,'<p class="articletext">Article Source:');
	$end = stripos($article_source,'</p>');
	$article_source = substr($article_source,0,$end);
	
	if ($keep_article_source){
		$article['description'] = $article['description'] . '<p>' . $article_source . '</p>';
	}
	//echo 'preparing author completed, returing to parent function...';

	return;
}

function as_addpost($title,$body,$tags='',$cat='',$guid){
	$my_post = array();
	$my_post['post_title'] = $title;
	$my_post['post_content'] = $body;
	$my_post['post_status'] = 'publish';
	$my_post['tags_input'] = $tags;

	$pid = wp_insert_post($my_post);
	if($pid){
		wp_set_post_categories($pid,array($cat));
		add_post_meta($pid,'article_guid',$guid);
		return $pid;
	} else {
		return false;
	}
}

function as_is_article_exists($guid){
	global $wpdb;

	$result = $wpdb->get_var("SELECT COUNT(*) FROM $wpdb->postmeta WHERE meta_value  LIKE '$guid'");

	if($result>0){
		return true;
	}
	return false;
}

function as_clean_title($title){
	//remove posted by phrase
	$title = substr($title,0,stripos($title,' Posted By:'));
	return $title;
}

function as_clean_description($description){
	$description = str_ireplace('<div class="articletext">','',$description);

	return $description;
}

function as_clean_author($author){
	//find 'Distributed by' portion
	$pos = stripos($author,'Distributed by');
	//echo "STR POS: $pos";
	if($pos !== false){
		$author = substr($author,0,$pos);
	}

	return $author;
}

function as_del_key($keyid){
	global $wpdb;
	$result = $wpdb->query("DELETE FROM {$wpdb->prefix}as_keywords WHERE `id` = {$wpdb->escape($keyid)}") or die($wpdb->last_error);
	return "Keyword ($keyid) is deleted";

}

function as_enable_disable_key($keyid,$status='inactive'){
	global $wpdb;
	$result = $wpdb->query("UPDATE {$wpdb->prefix}as_keywords SET `status`='{$wpdb->escape($status)}' WHERE `id`='{$wpdb->escape($keyid)}'") or die($wpdb->last_error);
	return "Keyword ($keyid) is disabled";

}

function as_process_single_key($keyid){
	global  $wpdb;
	//get key information from db
	$result = $wpdb->get_row("SELECT * FROM `{$wpdb->prefix}as_keywords` WHERE `id`='{$wpdb->escape($keyid)}'",ARRAY_A) or die($wpdb->last_error);

	$num_items = (empty($result['num_posts'])) ? 1 : $result['num_posts'];
	set_time_limit($num_items*45);
	echo as_fetch_articles($result['keyword'],$result['category'], $result['tags'],$result['author_dofollow_link'],$result['keep_article_source'],$num_items);
}

function as_post_selected_keywords($keywords){
	if(empty($keywords)){
		echo 'Sorry, no item is selected to process.';
		return;
	}
	foreach ($keywords as $keyword){
		as_process_single_key($keyword);
	}
}

function as_delete_selected_keywords($keywords){
	if(empty($keywords)){
		echo 'Sorry, no item is selected to process.';
		return;
	}
	foreach ($keywords as $keyword){
		echo as_del_key($keyword).'<br />';
	}
}

function as_handle_selected_keywords(){
	switch ($_POST['selected_type']){
		case 'post_selected':
			as_post_selected_keywords($_POST['keyword_id']);
			break;
		case 'delete':
			as_delete_selected_keywords($_POST['keyword_id']);
			break;
	}
}

function as_set_schedule(){
	if(!wp_next_scheduled('as_cron')){
		if(is_null(wp_schedule_event( time(), 'hourly','as_cron' ))){
			add_action('as_cron','as_process_cron');
			//wp_mail(get_option('admin_email'),'Auto Articles Cron Setup','Auto Articles cron has been setup successfully.');
		}
	}
}
function as_unset_schedule(){
	wp_unschedule_event(time(),'as_cron');
	wp_unschedule_event(time(),'as_process_cron');
	wp_clear_scheduled_hook('as_cron');
}
function as_spawn_cron(){
	//check if the cron was executed recently
	$last_cron_time = get_option('as_last_cron');
	$timestamp = strtotime("-1 minute");
	echo $last_cron_time;
	echo ' ,'.$timestamp;
	if(empty($last_cron_time) OR ($last_cron_time < $timestamp)){
		//as_process_cron();
		spawn_cron(time());
		update_option('as_last_cron',time());
	} else {
		//wp_mail(get_option('admin_email'),'cron is not run','it might have ran recently');
	}
}

function handle_author_dofollow($author, $author_dofollow) {
    $doc = new DOMDocument();
    @$doc->loadHTML($author);
    $links = $doc->getElementsByTagName('a');

	foreach($links as $link) {
		$rel = $link->getAttribute('rel');
		$rel = $author_dofollow ? remove_nofollow($rel) : add_nofollow($rel);
		if ($rel == "")
			$link->removeAttribute('rel');
		else
			$link->setAttribute('rel', $rel);
	}
	return preg_replace('/^<!DOCTYPE.+?>/', '', str_replace( array('<html>', '</html>', '<body>', '</body>'), array('', '', '', ''), $doc->saveHTML()));
}

function remove_nofollow($rel){
	return preg_replace("/nofollow/","", $rel);
}

function add_nofollow($rel){
	$rel_values = explode(" ",$rel);
	$rel_values[] = "nofollow";
	return implode(" ",array_unique($rel_values));
}

//add_filter('cron_schedules', 'as_reccurences');

?>
